#include <TMB.hpp>

template<class Type>
Type objective_function<Type>::operator() ()
{
  DATA_VECTOR(x);
  DATA_VECTOR(y);
  int n = y.size();

  PARAMETER(a);
  PARAMETER(b);
  PARAMETER(logSigma);
  Type sigma = exp(logSigma);
  ADREPORT(sigma);
  
  vector<Type> yfit(n);

  Type f = 0.0;

  yfit = a + b*x;
  f = (-1.0)*sum(dnorm(y, yfit, exp(logSigma), true));
  
  return f;
}

